# NornFlow Feature Roadmap

- [Current Capabilities](#current-capabilities)
- [Near-Term Priorities](#near-term-priorities)
  - [Advanced Filtering](#advanced-filtering)
  - [Output & Processing](#output--processing)
  - [Workflow Enhancements](#workflow-enhancements)
  - [Modular Component Sharing (Community Package Ecosystem)](#modular-component-sharing-community-package-ecosystem)
- [Future Enhancements](#future-enhancements)
  - [User Experience](#user-experience)
  - [Technical Foundation](#technical-foundation)
- [Continuous Improvement](#continuous-improvement)

This high-level roadmap outlines the strategic direction for NornFlow development.

## Current Capabilities

- **Core Functionality**: Task execution, workflow management, inventory handling
- **CLI Tools**: Basic commands for initialization, execution, and information display
- **Workflow Management**: YAML-based workflow definitions with task sequencing

## Near-Term Priorities

### Advanced Filtering
- Enhanced inventory filtering capabilities
- Support for custom/imported filter functions

### Output & Processing
- Support for custom/imported output processor support
- Enhanced result presentation

### Workflow Enhancements
- Conditional logic in workflows
- Loop structures

### Modular Component Sharing (Community Package Ecosystem)
- Support for importing tasks, filters, and processors from external Python packages
- Standardized package structure for NornFlow components
- Package discovery and automated registration mechanisms (not sure if required, as this could be simply a setting in nonrflow.yaml)
- Guidelines for developing shareable NornFlow components

## Future Enhancements

### User Experience
- Improved exception handling and error reporting

### Technical Foundation
- Settings management refinements
- Workflow, TaskModel and WorkflowModel classes most certainly can be improved. 🧠 ⚙️
- Documentation improvements

## Continuous Improvement

- Bug fixes and stability enhancements
- Performance optimizations
- Evaluate community input for general improvements

---

This roadmap will evolve based on user feedback and community priorities. Feature suggestions and contributions are welcome through our GitHub repository.


<div align="center">
  
## Navigation

<a href="./how_to_write_workflows.md">← Previous: Writing Workflows</a>

</div>